local rCCPortraits_Color0 = {r=0.1, g=1, b=0.3};
local rCCPortraits_Color1 = {r=0.9, g=0.93, b=0.04};
local rCCPortraits_Color2 = {r=0.9, g=0.55, b=0.03};
local rCCPortraits_Color3 = {r=0.85, g=0.04, b=0.04};

local rCCPortraits_ColorTime1 = 5;
local rCCPortraits_ColorTime2 = 9;
local rCCPortraits_ColorTime3 = 13;

--LABEL

function rCCPortraits_SetLabelText(timeRemaining, timeElapsed)
  if(timeElapsed > rCCPortraits_ColorTime3) then
    local color = rCCPortraits_Color3;
    rCCPortraits_Frame.label:SetText(rCCPortraits_GetLabelText(timeRemaining));
    rCCPortraits_Frame.label:SetTextColor(color.r, color.g, color.b);
  elseif(timeElapsed > rCCPortraits_ColorTime2) then
    local color = rCCPortraits_Color2;
    rCCPortraits_Frame.label:SetText(rCCPortraits_GetLabelText(timeRemaining));
    rCCPortraits_Frame.label:SetTextColor(color.r, color.g, color.b);
  elseif(timeElapsed > rCCPortraits_ColorTime1) then
    local color = rCCPortraits_Color1;
    rCCPortraits_Frame.label:SetText(rCCPortraits_GetLabelText(timeRemaining));
    rCCPortraits_Frame.label:SetTextColor(color.r, color.g, color.b);
  else
    local color = rCCPortraits_Color0;
    rCCPortraits_Frame.label:SetText(rCCPortraits_GetLabelText(timeRemaining));
    rCCPortraits_Frame.label:SetTextColor(color.r, color.g, color.b);
  end
end

function rCCPortraits_GetLabelText(timeRemaining)
  if(timeRemaining < 1.5) then
    return math.floor(timeRemaining * 10 + 0.5) / 10;
  else
    return math.floor(timeRemaining + 0.5);
  end
end

function rCCPortraits_CreateTargetFrame()
  local TargetFrame = _G[rCCPortraits_Anchors[rCCPortraits.rCCPortraits_Anchor].target];
  if(rCCPortraits.rCCPortraits_Anchor == "Perl" and Perl_Target_PortraitFrame ~= nil) then
    rCCPortraits_CreateTargetFramePerl();
    return
  end
  if(TargetFrame.portrait == nil) then
    TargetFrame = _G["TargetFrame"];
  end

  rCCPortraits_Frame:SetFrameLevel(TargetFrame:GetFrameLevel() + 1);
  rCCPortraits_Frame.texture = rCCPortraits_Frame:CreateTexture(nil,"BACKGROUND");
  rCCPortraits_Frame.cooldown = CreateFrame("Cooldown", "MEDIUM", rCCPortraits_Frame, "CooldownFrameTemplate");
  rCCPortraits_Frame.texture:SetPoint(TargetFrame.portrait:GetPoint());
  rCCPortraits_Frame.cooldown:SetSwipeTexture("Interface\\CHARACTERFRAME\\TempPortraitAlphaMaskSmall");
  rCCPortraits_Frame.cooldown:SetPoint(TargetFrame.portrait:GetPoint());
  local x, y = TargetFrame.portrait:GetWidth(), TargetFrame.portrait:GetHeight()
  rCCPortraits_Frame.cooldown:SetSize(x, y)
  rCCPortraits_Frame.texture:SetSize(x, y)

  --Circular
  if(rCCPortraits.rCCPortraits_Anchor == "Blizzard") then
    rCCPortraits_Frame.cooldown:SetUseCircularEdge(true);
    rCCPortraits_Frame.cooldown:SetDrawSwipe(true);
    rCCPortraits_Frame.texture:SetMask("Interface\\CHARACTERFRAME\\TemporaryPortrait-Monster");
  end

	rCCPortraits_Frame.label = rCCPortraits_LabelFrame:CreateFontString(nil, "TOOLTIP");
  local point, relativeTo, relativePoint, xOfs, yOfs = TargetFrame.portrait:GetPoint();
  rCCPortraits_Frame.label:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs - y / 2 + 18 / 2);
  rCCPortraits_Frame.label:SetWidth(x);
	rCCPortraits_Frame.label:SetJustifyH("CENTER")
	rCCPortraits_Frame.label:SetTextColor(1,1,1)
  rCCPortraits_Frame:SetFrameLevel(98);
  rCCPortraits_LabelFrame:SetFrameLevel(rCCPortraits_Frame:GetFrameLevel() + 1);
  rCCPortraits_Frame.label:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
  --HIDE LEVEL ICON
  rCCPortraits_Frame.texture:Hide();
end

function rCCPortraits_ToggleTexture(bool, texture, time, duration)
  if(bool) then
    TargetFrame.borderTexture:SetTexture([[Interface\TargetingFrame\UI-TargetingFrame-NoLevel]]);
    TargetFrameTextureFrameLevelText:Hide();
    rCCPortraits_Frame.texture:Show();
    rCCPortraits_Frame.cooldown:Show();
    rCCPortraits_Frame.texture:SetTexture(texture);
    rCCPortraits_Frame.cooldown:SetUseCircularEdge(true);
    rCCPortraits_Frame.cooldown:SetCooldown(time - 20, duration);
  	rCCPortraits_Frame.label:Show();
    local timeLeft = time - 20 + duration - GetTime();
    rCCPortraits_SetLabelText(timeLeft, duration - timeLeft);
  else
    rCCPortraits_Frame.texture:Hide();
  	rCCPortraits_Frame.label:Hide();
    TargetFrameTextureFrameLevelText:Show();
    rCCPortraits_Frame.cooldown:Hide();
    TargetFrame.borderTexture:SetTexture([[Interface\TargetingFrame\UI-TargetingFrame]]);
  end
end

function rCCPortraits_CreateTargetFramePerl()
  --TODO: Fix scaling issue.
  rCCPortraits_Frame:SetFrameLevel(TargetFrame:GetFrameLevel() + 1);
  rCCPortraits_Frame.texture = rCCPortraits_Frame:CreateTexture(nil,"BACKGROUND");
  rCCPortraits_Frame.cooldown = CreateFrame("Cooldown", "MEDIUM", rCCPortraits_Frame, "CooldownFrameTemplate");
  rCCPortraits_Frame.texture:SetPoint(Perl_Target_PortraitFrame:GetPoint());
  rCCPortraits_Frame.cooldown:SetSwipeTexture("Interface\\CHARACTERFRAME\\TempPortraitAlphaMaskSmall");
  rCCPortraits_Frame.cooldown:SetPoint(Perl_Target_PortraitFrame:GetPoint());
  local x, y = Perl_Target_PortraitFrame:GetWidth(), Perl_Target_PortraitFrame:GetHeight()
  rCCPortraits_Frame.cooldown:SetSize(x, y)
  rCCPortraits_Frame.texture:SetSize(x, y)
	rCCPortraits_Frame.label = rCCPortraits_LabelFrame:CreateFontString(nil, "TOOLTIP");
  local point, relativeTo, relativePoint, xOfs, yOfs = Perl_Target_PortraitFrame:GetPoint();
  rCCPortraits_Frame.label:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs - y / 2 + 18 / 2);
  rCCPortraits_Frame.label:SetWidth(x);
	rCCPortraits_Frame.label:SetJustifyH("CENTER")
	rCCPortraits_Frame.label:SetTextColor(1,1,1)
  rCCPortraits_Frame:SetFrameLevel(98);
  rCCPortraits_LabelFrame:SetFrameLevel(rCCPortraits_Frame:GetFrameLevel() + 1);
  rCCPortraits_Frame.label:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
  rCCPortraits_Frame.cooldown:SetUseCircularEdge(true);
  rCCPortraits_Frame.cooldown:SetDrawSwipe(true);
  rCCPortraits_Frame.texture:SetMask("Interface\\CHARACTERFRAME\\TemporaryPortrait-Monster");
  --HIDE LEVEL ICON
  rCCPortraits_Frame.texture:Hide();
end
