function rCCPortraits_CreateOptions()
  local options = CreateFrame("Frame", "rCCPortraits_Options")
  options.name = "rCCPortraits"
  InterfaceOptions_AddCategory(options);
  rCCPortraits_Options_CreateLabel(0, 0, "Unit Frames");
  rCCPortraits_Options_CreateUnitFrameMenu(-17, 20);
end

function rCCPortraits_Options_CreateLabel(xOffset, yOffset, text)
  local uiObject = rCCPortraits_Options:CreateFontString(nil, "Overlay");
  uiObject:SetPoint("TOPLEFT", xOffset + 16, -yOffset - 16);
	uiObject:SetTextColor(1, 0.8, 0);
  uiObject:SetFont("Fonts\\FRIZQT__.TTF", 16);
  uiObject:SetText(text);
end

function rCCPortraits_Options_CreateUnitFrameMenu(xOffset, yOffset)
  local uiObject = CreateFrame("Frame", nil, rCCPortraits_Options, "UIDropDownMenuTemplate");
  uiObject:SetPoint("TOPLEFT", xOffset + 16, -yOffset - 16);
  UIDropDownMenu_JustifyText(uiObject, "LEFT");
  UIDropDownMenu_Initialize(uiObject, MyDropDownMenu_OnLoad);
  UIDropDownMenu_SetWidth(uiObject, 160)
  UIDropDownMenu_SetText(uiObject, rCCPortraits.rCCPortraits_Anchor)
  UIDropDownMenu_Initialize(uiObject, function(self, level, menuList)
    local info = UIDropDownMenu_CreateInfo()
    for k, v in pairs(rCCPortraits_Anchors) do
     info.text = k
     info.func = self.SetValue
     info.disabled = _G[v["target"]] == nil;
     info.checked = info.text == rCCPortraits.rCCPortraits_Anchor;
     info.arg1 = info.text;
     if(info.checked and info.disabled) then
       info.checked = false;
       rCCPortraits.rCCPortraits_Anchor = "Blizzard";
       UIDropDownMenu_SetText(uiObject, rCCPortraits.rCCPortraits_Anchor)
     end
     UIDropDownMenu_AddButton(info);
    end
  end)

  function uiObject:SetValue(newValue)
    rCCPortraits.rCCPortraits_Anchor = newValue
    UIDropDownMenu_SetText(uiObject, newValue)
    CloseDropDownMenus()
    ReloadUI();
  end
end
